//
// Joker's b_unit project
//
// , , ,   
//   AVR ATmega8.
//
// ,    
//    
//
// URL: http://www.joker-tmn.narod.ru/b_unit.htm
//
// email: joker-tmn@yandex.ru
//

#include <mega8.h>

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x18 ;PORTB
   .equ __w1_bit=7
#endasm
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds1820.h>

// maximum number of DS1820 devices
// connected to the 1 Wire bus
#define MAX_DS1820 8
// DS1820 devices ROM code storage area,
// 9 bytes are used for each device
// (see the w1_search function description in the help)
unsigned char ds1820_rom_codes[MAX_DS1820][9];

const unsigned char no_key_pressed=0xFF;
const char convert[10] = {0x3F,0x0c,0x76,0x5e,0x4d,0x5b,0x7b,0x0e,0x7f,0x5f};

eeprom signed char s_fan_mode=0;
eeprom signed char s_boil_mode=0;
eeprom signed char s_b_on_hour=5;
eeprom signed char s_b_on_min=5;
eeprom signed char s_b_off_hour=21;
eeprom signed char s_b_off_min=0;
eeprom signed char s_displ_mode=3;
eeprom signed char s_t_correction=50;
eeprom signed char s_termshd=50;
eeprom signed char s_term_on_tempr=20;
eeprom signed char s_term_off_tempr=30;
eeprom signed char s_term_mode=2;

unsigned char sec100,sec=1,min=0,hour=5,
              flag1,buffer[4],half_sec_count,
              cputick,key,delay;

signed char fan_mode=0,boil_mode=0,b_on_hour=0,
    b_on_min=0,b_off_hour=0, b_off_min=0,
    displ_mode=0,t_correction=50,
    menulvl=0,smenulvl=0,menushowtimeremain=0,
    smenuenter=0,savevalue=0,tvalue=0,
    termshd=0,term_on_tempr=0,
    term_off_tempr=0,term_mode=0,tempr=25;

void time ();
void pause(int); 
void scanLED();
void timeToBuffer();
void blink();
void keyexe();
void keydelay();
void showOnce();
void showmenu();
void tvalue2buffer(signed char);
void tvalueauonoftext2buffer(signed char cv);
void checktvalue(signed char,signed char);

interrupt [TIM1_OVF] void timer1_ovf_isr(void)// Timer 1 overflow interrupt service routine
{
// Reinitialize Timer 1 value
TCNT1H=0xFD;//FD
TCNT1L=0x7f+t_correction-50;//8D//8E;//8F
// update realtime clock
cputick++;
time();
}

void time () //update real-time clock
{
   sec100++;
   if (sec100 >= 100)       /* 100 * 10 ms = 1 s */
   {sec100 = 0;
    flag1 |= 0x05;   /* set bit 0, bit 2 */
    half_sec_count = 50;
    sec++;
    if (menushowtimeremain>0)
            menushowtimeremain--;
    if (sec >= 60)
    {sec = 0;
     flag1 |= 0x02; /* set bit 1 */
     min++;
     if (min >= 60)
     {min = 0;
     hour++;
     if (hour >= 24)
     {hour = 0;
    }
  }
 }
}
}

void timeToBuffer()
{
    buffer[0] = convert[min%10];
    buffer[1] = convert[min/10];
    buffer[2] = convert[hour%10];
    buffer[3] = convert[hour/10];
}

void scanLED() // scan 4-digit LED and 5-key switch, if key pressed key = 0-4 
{
    int i;
    int digit = 0x20;
    key = no_key_pressed;
    for( i = 0; i <= 4; i++)  /* 4-DIGIT scanning +1 */
      {
        PORTC = ~digit;  /* send complement[digit] */
        if( i<4 )
              {
              PORTD = ~buffer[3-i];  /* send complement[segment] */
              pause(10);         /* delay a while */
              PORTD = 0xff;/* off LED */
              }
        pause(10);
        if (~PINC & 0x01==1) /* if key pressed P3.4 became low */
           {key = i;}       /* save key position to key variable */
        digit>>=1;//        /* next digit */
      }
}

void keyexe()
{
    if (key != no_key_pressed)
    {
          if ((flag1 & 0x80) == 0)  /* within 0.5 sec after 1st press
                                    the following execution is not allowed */
            {
                flag1 |= 0x80;
                delay = 40;
                menushowtimeremain=15;
                savevalue=0x00;
                
      		switch(key)
		{
        	 case (0): /* key position 0  sel*/
                   menulvl++;
                   smenulvl=0;
	           smenuenter=0xff;
		   break;
        	 case (1): /* key position 1  value*/
                   smenulvl++;
                   smenuenter=0xff;
                   if (menulvl==0)
                        {
                        menulvl=1;
                        smenulvl=4;
                        smenuenter=0xff;
                        menushowtimeremain=5;
                        }           
		   break;
	         case (2): /* key position 2  +*/
	           if (smenulvl!=0)
                           {tvalue++;
                           smenuenter=0x00;}
                   if (menulvl==0)
                        {
                        menulvl=2;
                        smenulvl=5;
                        smenuenter=0xff;
                        menushowtimeremain=5;
                        }                                      
		   break;
	         case (3): /* key position 3  -*/
	           if (smenulvl!=0)
                           {tvalue--;
                           smenuenter=0x00;}                       
                   if (menulvl==0)
                        {
                        menulvl=3;
                        smenulvl=1;
                        smenuenter=0xff;
                        menushowtimeremain=5;
                        }                                      
		   break;
	         case (4): /* key position 4  save*/	           
                   savevalue=0xff;	         
                   if (menulvl==0)
                        {
                        menulvl=4;
                        smenulvl=1;
                        smenuenter=0xff;
                        menushowtimeremain=5;
                        }
	           break;
	        }
            }	        
    }
}

void showmenu()
{
//  -     
//  ,   0  
switch(menulvl)
      {
      case (1): /* tempr controlmenu*/
        buffer[3] = 0x71;// t
        buffer[2] = 0x73;// e                
        buffer[1] = 0x68;// m        
        buffer[0] = 0x67;// p
        break;
      case (2): /* boul controlmenu*/
        buffer[3] = 0x79;// b
        buffer[2] = 0x78;// o
        buffer[1] = 0x3D;// u        
        buffer[0] = 0x31;// l                
        break;
      case (3): /* fan controlmenu*/
        buffer[3] = 0x63;// f
        buffer[2] = 0x6f;// a
        buffer[1] = 0x68;// m        
        buffer[0] = 0x00;//
        break;
      case (4): /* disp controlmenu*/
        buffer[3] = 0x7C;// d
        buffer[2] = 0x21;// i        
        buffer[1] = convert[5];// s        
        buffer[0] = 0x67;// p
        break;
      case (5): /* time controlmenu*/
        buffer[3] = 0x71;// t
        buffer[2] = 0x29;// I+i
        buffer[1] = 0x68;// m        
        buffer[0] = 0x73;// e                
        break;
      case (6): /* menu end */
        menulvl=0;
        menushowtimeremain=0;
      }
// ,       
//    email: joker-tmn@yandex.ru
}

void checktvalue(signed char l,signed char h)
{
if(tvalue>h)
     tvalue=l; 
if(tvalue<l)
     tvalue=h;                    
}

void tvalueauonoftext2buffer(signed char cv)
{
switch(tvalue)
     {
        case(0):
          buffer[1] = 0x6f;// a
          buffer[0] = 0x3D;// u
          break;
        case(1):
          buffer[1] = 0x78;// o
          buffer[0] = 0x68;// n
          break;
        case(2):
          buffer[1] = 0x78;// o
          buffer[0] = 0x63;// f
          break;                        
     }
if (cv!=tvalue)
    buffer[3] |= 0x80;                   
}

void tvalue2buffer(signed char cv)
{
buffer[1] = convert[tvalue/10];
buffer[0] = convert[tvalue%10];
if (cv!=tvalue)
    buffer[3] |= 0x80;                
}

void blink()
{
    if((flag1 & 0x04) != 0) /* check bit 2 if set decrement temp until zero */
     {half_sec_count--;
        if (half_sec_count != 0)
                {
                buffer[1] |= 0x80;
                buffer[2] |= 0x80;
                }
        else( flag1 &= ~0x04);
     }
}

void keydelay()
{
    if ((flag1 & 0x80) !=0)
        {
        delay--;
        if(delay == 0)
            flag1 &= ~0x80;
        }
}

void showOnce()
{
 int i;
 for(i=0;i<3000;i++)
        scanLED();
}

void pause(int j)
{
   int i;
   for (i = 0; i < j; i++)
   	{;}
}

void main(void)
{
PORTB=0x00;
DDRB=0x07;

PORTC=0x01;
DDRC=0x3E;

PORTD=0x00;
DDRD=0xFF;

TCCR0=0x00;
TCNT0=0x00;

TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0xFD;
OCR1AL=0x8F;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

ACSR=0x80;
SFIOR=0x00;
       
key = no_key_pressed;
flag1 = 0;

termshd=s_termshd;
term_on_tempr=s_term_on_tempr;
term_off_tempr=s_term_off_tempr;
term_mode=s_term_mode;
fan_mode=s_fan_mode;
boil_mode=s_boil_mode;
b_on_hour=s_b_on_hour;
b_on_min=s_b_on_min;
b_off_hour=s_b_off_hour;
b_off_min=s_b_off_min;
displ_mode=s_displ_mode;
t_correction=s_t_correction;

buffer[0] = 0x40;
buffer[1] = 0x40;
buffer[2] = 0x40;
buffer[3] = 0x40;

// Determine the number of DS1820 devices
// connected to the 1 Wire bus
w1_search(0xf0,ds1820_rom_codes);

#asm("sei")   

while (1)
  {
    while ( cputick < 1)
	    scanLED();
    cputick = 0;
    if (menulvl==0)
        {
         timeToBuffer();
         blink();
// ,       
//    email: joker-tmn@yandex.ru
        }
    else
       {
       showmenu();
       if (menushowtimeremain<1)
         menulvl=0;     
       }
    keyexe();
    keydelay();       
  }
  
}
